/*
 *  ircd-ratbox: A slightly useful ircd.
 *  rsa.h: A header for the RSA functions.
 *
 *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
 *  Copyright (C) 1996-2002 Hybrid Development Team
 *  Copyright (C) 2002 ircd-ratbox development team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: rsa.h,v 7.15.4.1 2003/06/26 14:01:41 androsyn Exp $
 */
#ifndef INCLUDED_rsa_h
#define INCLUDED_rsa_h 1

#ifdef HAVE_LIBCRYPTO
extern void report_crypto_errors(void);
extern int verify_private_key(void);
extern int generate_challenge(char **r_challenge, char **r_response, RSA * key);
extern int crypt_data(char **out, char *in, int len, char *key);
extern int decrypt_data(char **out, char *in, int len, char *key);
extern int get_randomness(unsigned char *buf, int length);
#endif

#endif /* INCLUDED_rsa_h */
